function [anl] = Analysis(func, varargin)

anl.func = func;
if isa(func, 'function_handle')
	func_str = func2str(func);
else
	func_str = func;
end
anl.cachefile = sprintf('%s-eval-cache.mat', func_str);
anl.cache = cell(0,3);
anl.count = 0;

% statistics
anl.evals = 0;
anl.hits = 0;

% default parameter values
anl.use_cache = 0;

% define parameters
params = param_analysis([]);
param_value = [];
if nargin == 2, param_value = varargin{1}; end
param = Paramset(params, param_value);

% load parameters
anl.use_cache = param.analysis_cache;

anl = class(anl, 'Analysis');

% Reset evals/hits counters
anl = load_cache(anl, 0);
save_cache(anl);

return
