function [newpop] = reduce_age(pop, N, lifespan)
% Retain 'elite' and 'young' individuals from parent population

newpop = Population(pop, N);

id = find(pop.age(pop.rank) < lifespan);
if length(id) < N
	error('too many old people');
end
rank = pop.rank(id(1:N));

newpop.x = pop.x(rank, :);
newpop.f = pop.f(rank, :);
newpop.g = pop.g(rank, :);
newpop.feas = pop.feas(rank);
newpop.rank = (1:N)';
newpop.age = pop.age(rank);
newpop.eval = pop.eval(rank);

newpop.cv = pop.cv(rank);
newpop.nd_rank = pop.nd_rank(rank);
newpop.crowd = pop.crowd(rank);

return
