function [pop] = sort_idea(pop, inf_ratio, f_new)

pop.nd_rank = zeros(pop.size,1);
pop.crowd = zeros(pop.size,1);

feasible = find(pop.feas == 1);
infeasible = find(pop.feas == 0);

% sort feasible solutions
ranks1 = [];
if ~isempty(feasible)
	[ranks1, nd_rank, crowd] = sort_obj(pop.f, feasible);
	pop.nd_rank(feasible) = nd_rank(feasible);
	pop.crowd(feasible) = crowd(feasible);
end

% sort infeasible solutions
ranks2 = [];
if ~isempty(infeasible)
	if length(infeasible) == pop.size
		ranks2 = sort_constr(pop.cv, infeasible);
	else
		[ranks2, nd_rank, crowd] = sort_obj([pop.f f_new], infeasible);
		pop.nd_rank(infeasible) = - nd_rank(infeasible);
		pop.crowd(infeasible) = crowd(infeasible);
	end
end

assert(length(ranks1)+length(ranks2) == pop.size);
pop.rank = [ranks1; ranks2];

% promote infeasible solutions
N_inf = min(sum(pop.feas == 0), round(inf_ratio/2 * pop.size));
pop = promote_infeasible(pop, N_inf);

return
